#ifndef PLANE_H
#define PLANE_H

#include "materialmodel.h"
#include "lightablemodel.h"
#include "movablemodel.h"
#include "indexmodel.h"
#include "texturemodel.h"
#include "bumpmodel.h"
#include "matma.h"
#include "vertices.h"
#include "bumppointlightprogram.h"

class Plane :
        public IndexModel,
        public LightableModel,
        public MovableModel,
        public TextureModel,
        public BumpModel,
        public MaterialModel{
public:
    void Initialize(GLint m, GLint n);
    void Draw(const BumpPointLightProgram & program) const;
private:
    GLuint n_; // mesh parameter
    GLuint m_; // mesh parameter

};

#endif // PLANE_H
